Taylor UUCP - Taylor UUCP Configuration Files

Go to the first, previous, next, last section, table of contents.

# Taylor UUCP Configuration Files

This chapter describes the configuration files accepted by the Taylor UUCP package if compiled with `HAVE_TAYLOR_CONFIG` set to 1 in ``policy.h'`.

The configuration files are normally found in the directory newconfigdir, which is defined by the ``Makefile'` variable ``newconfigdir'`; by default newconfigdir is ``/usr/local/conf/uucp'`. However, the main configuration file, ``config'`, is the only one which must be in that directory, since it may specify a different location for any or all of the other files. You may run any of the UUCP programs with a different main configuration file by using the ``-I'` or ``--config'` option; this can be useful when testing a new configuration. When you use the ``-I'` option the programs will revoke any setuid privileges.

- Configuration Overview: Configuration File Overview
- Configuration File Format: Configuration File Format
- Configuration Examples: Examples of Configuration Files
- Time Strings: How to Write Time Strings
- Chat Scripts: How to Write Chat Scripts
- config File: The Main Configuration File
- sys File: The System Configuration File
- port File: The Port Configuration Files
- dial File: The Dialer Configuration Files
- UUCP Over TCP: UUCP Over TCP
- Security: Security Issues

## Configuration File Overview

UUCP uses several different types of configuration files, each describing a different kind of information. The commands permitted in each file are described in detail below. This section is a brief description of some of the different types of files.

The ``config'` file is the main configuration file. It describes general information not associated with a particular remote system, such as the location of various log files. There are reasonable defaults for everything that may be specified in the ``config'` file, so you may not actually need one on your system.

There may be only one ``config'` file, but there may be one or more of each other type of file. The default is one file for each type, but more may be listed in the ``config'` file.

The ``sys'` files are used to describe remote systems. Each remote system to which you connect must be listed in a ``sys'` file. A ``sys'` file will include information for a system, such as the speed (baud rate) to use, or when to place calls.

For each system you wish to call, you must describe one or more ports; these ports may be defined directly in the ``sys'` file, or they may be defined in a ``port'` file.

The ``port'` files are used to describe ports. A port is a particular hardware connection on your computer. You would normally define as many ports as there are modems attached to your computer. A TCP connection is also described using a port.

The ``dial'` files are used to describe dialers. Dialer is essentially another word for modem. The ``dial'` file describes the commands UUCP should use to dial out on a particular type of modem. You would normally define as many dialers as there are types of modems attached to your computer. For example, if you have three Telebit modems used for UUCP, you would probably define three ports and one dialer.

There are other types of configuration files, but these are the important ones. The other types are described below.

## Configuration File Format

All the configuration files follow a simple line-oriented ``keyword value'` format. Empty lines are ignored, as are leading spaces; unlike HDB, lines with leading spaces are read. The first word on each line is a keyword. The rest of the line is interpreted according to the keyword. Most keywords are followed by numbers, boolean values or simple strings with no embedded spaces.

The `#` character is used for comments. Everything from a `#` to the end of the line is ignored unless the `#` is preceded by a `\` (backslash); if the `#` is preceeded by a `\`, the `\` is removed but the `#` remains in the line. This can be useful for a phone number containing a `#`. To enter the sequence ``\#'`, use ``\\#'`.

The backslash character may be used to continue lines. If the last character in a line is a backslash, the backslash is removed and the line is continued by the next line. The second line is attached to the first with no intervening characters; if you want any whitespace between the end of the first line and the start of the second line, you must insert it yourself.

However, the backslash is not a general quoting character. For example, you cannot use it to get an embedded space in a string argument.

Everything after the keyword must be on the same line. A boolean may be specified as `y`, `Y`, `t`, or `T` for true and `n`, `N`, `f`, or `F` for false; any trailing characters are ignored, so `true`, `false`, etc., are also acceptable.

## Examples of Configuration Files

This section provides few typical examples of configuration files. There are also sample configuration files in the ``sample'` subdirectory of the distribution.

- config File Examples: Examples of the Main Configuration File
- Leaf Example: Call a Single Remote Site
- Gateway Example: The Gateway for Several Local Systems

### config File Examples

To start with, here are some examples of uses of the main configuration file, ``config'`. For a complete description of the commands that are permitted in ``config'`, see section The Main Configuration File.

In many cases you will not need to create a ``config'` file at all. The most common reason to create one is to give your machine a special UUCP name. Other reasons might be to change the UUCP spool directory, or to permit any remote system to call in.

If you have an internal network of machines, then it is likely that the internal name of your UUCP machine is not the name you want to use when calling other systems. For example, here at ``airs.com'` our mail/news gateway machine is named ``elmer.airs.com'` (it is one of several machines all named ``localname.airs.com'`). If we did not provide a ``config'` file, then our UUCP name would be ``elmer'`; however, we actually want it to be ``airs'`. Therefore, we use the following line in ``config'`:

    nodename airs

The UUCP spool directory name is set in ``policy.h'` when the code is compiled. You might at some point decide that it is appropriate to move the spool directory, perhaps to put it on a different disk partition. You would use the following commands in ``config'` to change to directories on the partition ``/uucp'`:

    spool /uucp/spool
    pubdir /uucp/uucppublic
    logfile /uucp/spool/Log
    debugfile /uucp/spool/Debug

You would then move the contents of the current spool directory to ``/uucp/spool'`. If you do this, make sure that no UUCP processes are running while you change ``config'` and move the spool directory.

Suppose you wanted to permit any system to call in to your system and request files. This is generally known as anonymous UUCP, since the systems which call in are effectively anonymous. By default, unknown systems are not permitted to call in. To permit this you must use the `unknown` command in ``config'`. The `unknown` command is followed by any command that may appear in the system file; for full details, see section The System Configuration File.

I will show two possible anonymous UUCP configurations. The first will let any system call in and download files, but will not permit them to upload files to your system.

    # No files may be transferred to this system
    unknown receive-request no
    # The public directory is /usr/spool/anonymous
    unknown pubdir /usr/spool/anonymous
    # Only files in the public directory may be sent (the default anyhow)
    unknown remote-send ~

Setting the public directory is convenient for the systems which call in. It permits to request a file by prefixing it with ``~/'`. For example, assuming your system is known as ``server'`, then to retrieve the file ``/usr/spool/anonymous/INDEX'` a user on a remote site could just enter ``uucp server!~/INDEX ~'`; this would transfer ``INDEX'` from ``server'`'s public directory to the user's local public directory. Note that when using ``csh'` or ``bash'` the `!` and the second `~` must be quoted.

The next example will permit remote systems to upload files to a special directory named ``/usr/spool/anonymous/upload'`. Permitting a remote system to upload files permits it to send work requests as well; this example is careful to prohibit commands from unknown systems.

    # No commands may be executed (the list of permitted commands is empty)
    unknown commands
    # The public directory is /usr/spool/anonymous
    unknown pubdir /usr/spool/anonymous
    # Only files in the public directory may be sent; users may not download
    # files from the upload directory
    unknown remote-send ~ !~/upload
    # May only upload files into /usr/spool/anonymous/upload
    unknown remote-receive ~/upload

### Leaf Example

A relatively common simple case is a leaf site, a system which only calls or is called by a single remote site. Here is a typical ``sys'` file that might be used in such a case. For full details on what commands can appear in the ``sys'` file, see section The System Configuration File.

This is the ``sys'` file that is used at ``airs.com'`. We use a single modem to dial out to ``uunet'`. This example shows how you can specify the port and dialer information directly in the ``sys'` file for simple cases. It also shows the use of the following:

`call-login`
  Using `call-login` and `call-password` allows the default login chat script to be used. In this case, the login name is specified in the call-out login file (see section Configuration File Names).
`call-timegrade`
  ``uunet'` is requested to not send us news during the daytime.
`chat-fail`
  If the modem returns ``BUSY'` or ``NO CARRIER'` the call is immediately aborted.
`protocol-parameter`
  Since ``uunet'` tends to be slow, the default timeout has been increased.

This ``sys'` file relies on certain defaults. It will allow ``uunet'` to queue up ``rmail'` and ``rnews'` commands. It will allow users to request files from ``uunet'` into the UUCP public directory. It will also allow ``uunet'` to request files from the UUCP public directory; in fact ``uunet'` never requests files, but for additional security we could add the line ``request false'`.

    # The following information is for uunet
    system uunet

    # The login name and password are kept in the callout password file
    call-login *
    call-password *

    # We can send anything at any time.
    time any

    # During the day we only accept grade `Z' or above; at other times
    # (not mentioned here) we accept all grades.  uunet queues up news
    # at grade `d', which is lower than `Z'.
    call-timegrade Z Wk0755-2305,Su1655-2305

    # The phone number.
    phone 7389449

    # uunet tends to be slow, so we increase the timeout
    chat-timeout 120

    # We are using a preconfigured Telebit 2500.
    port type modem
    port device /dev/ttyd0
    port speed 19200
    port carrier true
    port dialer chat "" ATZ\r\d\c OK ATDT\D CONNECT
    port dialer chat-fail BUSY
    port dialer chat-fail NO\sCARRIER
    port dialer complete \d\d+++\d\dATH\r\c
    port dialer abort \d\d+++\d\dATH\r\c

    # Increase the timeout and the number of retries.
    protocol-parameter g timeout 20
    protocol-parameter g retries 10

### Gateway Example

Many organizations have several local machines which are connected by UUCP, and a single machine which connects to the outside world. This single machine is often referred to as a gateway machine.

For this example I will assume a fairly simple case. It should still provide a good general example. There are three machines, ``elmer'`, ``comton'` and ``bugs'`. ``elmer'` is the gateway machine for which I will show the configuration file. ``elmer'` calls out to ``uupsi'`. As an additional complication, ``uupsi'` knows ``elmer'` as ``airs'`; this will show how a machine can have one name on an internal network but a different name to the external world. ``elmer'` has two modems. It also has an TCP connection to ``uupsi'`, but since that is supposed to be reserved for interactive work (it is, perhaps, only a 9600 baud SLIP line) it will only use it if the modems are not available.

A network this small would normally use a single ``sys'` file. However, for pedagogical purposes I will show two separate ``sys'` files, one for the local systems and one for ``uupsi'`. This is done with the `sysfile` command in the ``config'` file. Here is the ``config'` file.

    # This is config
    # The local sys file
    sysfile /usr/local/lib/uucp/sys.local
    # The remote sys file
    sysfile /usr/local/lib/uucp/sys.remote

Using the defaults feature of the ``sys'` file can greatly simplify the listing of local systems. Here is ``sys.local'`. Note that this assumes that the local systems are trusted; they are permited to request any world readable file and to write files into any world writable directory.

    # This is sys.local
    # Get the login name and password to use from the call-out file
    call-login *
    call-password *

    # The systems must use a particular login
    called-login Ulocal

    # Permit sending any world readable file
    local-send /
    remote-send /

    # Permit receiving into any world writable directory
    local-receive /
    remote-receive /

    # Call at any time
    time any

    # Use port1, then port2
    port port1

    alternate

    port port2

    # Now define the systems themselves.  Because of all the defaults we
    # used, there is very little to specify for the systems themselves.

    system comton
    phone 5551212

    system bugs
    phone 5552424

The ``sys.remote'` file describes the ``uupsi'` connection. The `myname` command is used to change the UUCP name to ``airs'` when talking to ``uupsi'`.

    # This is sys.remote
    # Define uupsi
    system uupsi

    # The login name and password are in the call-out file
    call-login *
    call-password *

    # We can call out at any time
    time any

    # uupsi uses a special login name
    called-login Uuupsi

    # uuspi thinks of us as `airs'
    myname airs

    # The phone number
    phone 5554848

    # We use port2 first, then port1, then TCP

    port port2

    alternate

    port port1

    alternate

    # We don't bother to make a special entry in the port file for TCP, we
    # just describe the entire port right here.  We use a special chat
    # script over TCP because the usual one confuses some TCP servers.
    port type TCP
    address uu.psi.com
    chat ogin: \L word: \P

The ports are defined in the file ``port'` (see section The Port Configuration File). For this example they are both connected to the same type of 2400 baud Hayes-compatible modem.

    # This is port

    port port1
    type modem
    device /dev/ttyd0
    dialer hayes
    speed 2400

    port port2
    type modem
    device /dev/ttyd1
    dialer hayes
    speed 2400

Dialers are described in the ``dial'` file (see section The Dialer Configuration File).

    # This is dial

    dialer hayes

    # The chat script used to dial the phone.  \D is the phone number.
    chat "" ATZ\r\d\c OK ATDT\D CONNECT

    # If we get BUSY or NO CARRIER we abort the dial immediately
    chat-fail BUSY
    chat-fail NO\sCARRIER

    # When the call is over we make sure we hangup the modem.
    complete \d\d+++\d\dATH\r\c
    abort \d\d+++\d\dATH\r\c

## Time Strings

Several commands use time strings to specify a range of times. This section describes how to write time strings.

A time string may be a list of simple time strings separated with a vertical bar ``|'` or a comma ``,'`.

Each simple time string must begin with ``Su'`, ``Mo'`, ``Tu'`, ``We'`, ``Th'`, ``Fr'`, or ``Sa'`, or ``Wk'` for any weekday, or ``Any'` for any day.

Following the day may be a range of hours separated with a hyphen using 24 hour time. The range of hours may cross 0; for example ``2300-0700'` means any time except 7 AM to 11 PM. If no time is given, calls may be made at any time on the specified day(s).

The time string may also be the single word ``Never'`, which does not match any time. The time string may also be a single word with a name defined in a previous `timetable` command (see section Miscellaneous config File Commands).

Here are a few sample time strings with an explanation of what they mean.

``Wk2305-0855,Sa,Su2305-1655'`
  This means weekdays before 8:55 AM or after 11:05 PM, any time Saturday, or Sunday before 4:55 PM or after 11:05 PM. These are approximately the times during which night rates apply to phone calls in the U.S.A. Note that this time string uses, for example, ``2305'` rather than ``2300'`; this will ensure a cheap rate phone call even if the computer clock is running up to five minutes ahead of the real time.
``Wk0905-2255,Su1705-2255'`
  This means weekdays from 9:05 AM to 10:55 PM, or Sunday from 5:05 PM to 10:55 PM. This is approximately the opposite of the previous example.
``Any'`
  This means any day. Since no time is specified, it means any time on any day.

## Chat Scripts

Chat scripts are used in several different places, such as dialing out on modems or logging in to remote systems. Chat scripts are made up of pairs of strings. The program waits until it sees the first string, known as the expect string, and then sends out the second string, the send string.

Each chat script is defined using a set of commands. These commands always end in a string beginning with `chat`, but may start with different strings. For example, in the ``sys'` file there is one set of commands beginning with `chat` and another set beginning with `called-chat`. The prefixes are only used to disambiguate different types of chat scripts, and this section ignores the prefixes when describing the commands.

`chat strings`
  Specify a chat script. The arguments to the `chat` command are pairs of strings separated by whitespace. The first string of each pair is an expect string, the second is a send string. The program will wait for the expect string to appear; when it does, the program will send the send string. If the expect string does not appear within a certain number of seconds (as set by the `chat-timeout` command), the chat script fails and, typically, the call is aborted. If the final expect string is seen (and the optional final send string has been sent), the chat script is successful. An expect string may contain additional subsend and subexpect strings, separated by hyphens. If the expect string is not seen, the subsend string is sent and the chat script continues by waiting for the subexpect string. This means that a hyphen may not appear in an expect string; on an ASCII system, use ``\055'` instead. An expect string may simply be ``""'`, meaning to skip the expect phase. Otherwise, the following escape characters may appear in expect strings:
  ``\b'`
    a backspace character
  ``\n'`
    a newline or line feed character
  ``\N'`
    a null character (for HDB compatibility)
  ``\r'`
    a carriage return character
  ``\s'`
    a space character
  ``\t'`
    a tab character
  ``\\'`
    a backslash character
  ``\ddd'`
    character ddd, where ddd are up to three octal digits
  ``\xddd'`
    character ddd, where ddd are hexadecimal digits.
  As in C, there may be up to three octal digits following a backslash, but the hexadecimal escape sequence continues as far as possible. To follow a hexadecimal escape sequence with a hex digit, interpose a send string of ``""'`. A chat script expect string may also specify a timeout. This is done by using the escape sequence ``\Wseconds'`. This escape sequence may only appear at the very end of the expect string. It temporarily overrides the timeout set by `chat-timeout` (described below) only for the expect string to which it is attached. A send string may simply be ``""'` to skip the send phase. Otherwise, all of the escape characters legal for expect strings may be used, and the following escape characters are also permitted:
  ``EOT'`
    send an end of transmission character (`^D`)
  ``BREAK'`
    send a break character (may not work on all systems)
  ``\c'`
    suppress trailing carriage return at end of send string
  ``\d'`
    delay sending for 1 or 2 seconds
  ``\e'`
    disable echo checking
  ``\E'`
    enable echo checking
  ``\K'`
    same as ``BREAK'` (for HDB compatibility)
  ``\p'`
    pause sending for a fraction of a second
  Some specific types of chat scripts also define additional escape sequences that may appear in the send string. For example, the login chat script defines ``\L'` and ``\P'` to send the login name and password, respectively. A carriage return will be sent at the end of each send string, unless the `\c` escape sequence appears in the string. Note that some UUCP packages use `\b` for break, but here it means backspace. Echo checking means that after writing each character the program will wait until the character is echoed. Echo checking must be turned on separately for each send string for which it is desired; it will be turned on for characters following `\E` and turned off for characters following `\e`.
`chat-timeout number`
  The number of seconds to wait for an expect string in the chat script, before timing out and sending the next subsend, or failing the chat script entirely. The default value is 10 for a login chat or 60 for any other type of chat.
`chat-fail string`
  If the string is seen at any time during a chat script, the chat script is aborted. The string may not contain any whitespace characters: escape sequences must be used for them. Multiple `chat-fail` commands may appear in a single chat script. The default is to have none. This permits a chat script to be quickly aborted if an error string is seen. For example, a script used to dial out on a modem might use the command ``chat-fail BUSY'` to stop the chat script immediately if the string ``BUSY'` was seen. The `chat-fail` strings are considered in the order they are listed, so if one string is a suffix of another the longer one should be listed first. This affects the error message which will be logged. Of course, if one string is contained within another, but is not a suffix, the smaller string will always be found before the larger string could match.
`chat-seven-bit boolean`
  If the argument is true, all incoming characters are stripped to seven bits when being compared to the expect string. Otherwise all eight bits are used in the comparison. The default is true, because some Unix systems generate parity bits during the login prompt which must be ignored while running a chat script. This has no effect on any `chat-program`, which must ignore parity by itself if necessary.
`chat-program strings`
  Specify a program to run before executing the chat script. This program could run its own version of a chat script, or it could do whatever it wants. If both `chat-program` and `chat` are specified, the program is executed first followed by the chat script. The first argument to the `chat-program` command is the program name to run. The remaining arguments are passed to the program. The following escape sequences are recognized in the arguments:
  `\Y`
    port device name
  `\S`
    port speed
  `\\`
    backslash
  Some specific uses of `chat-program` define additional escape sequences. Arguments other than escape sequences are passed exactly as they appear in the configuration file, except that sequences of whitespace are compressed to a single space character (this exception may be removed in the future). If the `chat-program` command is not used, no program is run. On Unix, the standard input and standard output of the program will be attached to the port in use. Anything the program writes to standard error will be written to the UUCP log file. No other file descriptors will be open. If the program does not exit with a status of 0, it will be assumed to have failed. This means that the dialing programs used by some versions of HDB may not be used directly, but you may be able to run them via the `dialHDB` program in the ``contrib'` directory. The program will be run as the `uucp` user, and the environment will be that of the process that started `uucico`, so care must be taken to maintain security. No search path is used to find the program; a full file name must be given. If the program is an executable shell script, it will be passed to ``/bin/sh'` even on systems which are unable to execute shell scripts.

Here is a simple example of a chat script that might be used to reset a Hayes compatible modem.

    chat "" ATZ OK-ATZ-OK

The first expect string is ``""'`, so it is ignored. The chat script then sends ``ATZ'`. If the modem responds with ``OK'`, the chat script finishes. If 60 seconds (the default timeout) pass before seeing ``OK'`, the chat script sends another ``ATZ'`. If it then sees ``OK'`, the chat script succeeds. Otherwise, the chat script fails.

For a more complex chat script example, see section Logging In.

## The Main Configuration File

The main configuration file is named ``config'`.

Since all the values that may be specified in the main configuration file also have defaults, there need not be a main configuration file at all.

Each command in ``config'` may have a program prefix, which is a separate word appearing at the beginning of the line. The currently supported prefixes are ``uucp'` and ``cu'`. Any command prefixed by ``uucp'` will not be read by the `cu` program. Any command prefixed by ``cu'` will only be read by the `cu` program. For example, to use a list of systems known only to `cu`, list them in a separate file ``file'` and put ``cu sysfile ``file'`'` in ``config'`.

- Miscellaneous (config): Miscellaneous config File Commands
- Configuration File Names: Using Different Configuration Files
- Log File Names: Using Different Log Files
- Debugging Levels: Debugging Levels

### Miscellaneous config File Commands

`nodename string`
`hostname string`
`uuname string`
  These keywords are equivalent. They specify the UUCP name of the local host. If there is no configuration file, an appropriate system function will be used to get the host name, if possible.
`spool string`
  Specify the spool directory. The default is from ``policy.h'`. This is where UUCP files are queued. Status files and various sorts of temporary files are also stored in this directory and subdirectories of it.
`pubdir string`
  Specify the public directory. The default is from ``policy.h'`. When a file is named using a leading `~/`, it is taken from or to the public directory. Each system may use a separate public directory by using the `pubdir` command in the system configuration file; see section Miscellaneous sys File Commands.
`lockdir string`
  Specify the directory to place lock files in. The default is from ``policy.h'`; see the information in that file. Normally the lock directory should be set correctly in ``policy.h'`, and not changed here. However, changing the lock directory is sometimes useful for testing purposes. This only affects lock files for devices and systems; it does not affect certain internal lock files which are stored in the spool directory (see section Lock Files in the Spool Directory).
`unknown string ...`
  The string and subsequent arguments are treated as though they appeared in the system file (see section The System Configuration File). They are used to apply to any unknown systems that may call in, probably to set file transfer permissions and the like. If the `unknown` command is not used, unknown systems are not permitted to call in.
`strip-login boolean`
  If the argument is true, then, when `uucico` is doing its own login prompting with the ``-e'`, ``-l'`, or ``-w'` switches, it will strip the parity bit when it reads the login name and password. Otherwise all eight bits will be used when checking the strings against the UUCP password file. The default is true, since some other UUCP packages send parity bits with the login name and password, and few systems use eight bit characters in the password file.
`strip-proto boolean`
  If the argument is true, then `uucico` will strip the parity bit from incoming UUCP protocol commands. Otherwise all eight bits will be used. This only applies to commands which are not encapsulated in a link layer protocol. The default is true, which should always be correct unless your UUCP system names use eight bit characters.
`max-uuxqts number`
  Specify the maximum number of `uuxqt` processes which may run at the same time. Having several `uuxqt` processes running at once can significantly slow down a system, but, since `uuxqt` is automatically started by `uucico`, it can happen quite easily. The default for `max-uuxqts` is 0, which means that there is no limit. If HDB configuration files are being read and the code was compiled without `HAVE_TAYLOR_CONFIG`, then, if the file ``Maxuuxqts'` in the configuration directory contains a readable number, it will be used as the value for `max-uuxqts`.
`run-uuxqt string or number`
  Specify when `uuxqt` should be run by `uucico`. This may be a positive number, in which case `uucico` will start a `uuxqt` process whenever it receives the given number of execution files from the remote system, and, if necessary, at the end of the call. The argument may also be one of the strings ``once'`, ``percall'`, or ``never'`. The string ``once'` means that `uucico` will start `uuxqt` once at the end of execution. The string ``percall'` means that `uucico` will start `uuxqt` once per call that it makes (this is only different from `once` when `uucico` is invoked in a way that causes it to make multiple calls, such as when the ``-r1'` option is used without the ``-s'` option). The string ``never'` means that `uucico` will never start `uuxqt`, in which case `uuxqt` should be periodically run via some other mechanism. The default depends upon which type of configuration files are being used; if `HAVE_TAYLOR_CONFIG` is used the default is ``once'`, otherwise if `HAVE_HDB_CONFIG` is used the default is ``percall'`, and otherwise, for `HAVE_V2_CONFIG`, the default is ``10'`.
`timetable string string`
  The `timetable` defines a timetable that may be used in subsequently appearing time strings; see section Time Strings. The first string names the timetable entry; the second is a time string. The following `timetable` commands are predefined. The NonPeak timetable is included for compatibility. It originally described the offpeak hours of Tymnet and Telenet, but both have since changed their schedules.

      timetable Evening Wk1705-0755,Sa,Su
      timetable Night Wk2305-0755,Sa,Su2305-1655
      timetable NonPeak Wk1805-0655,Sa,Su

  If this command does not appear, then, obviously, no additional timetables will be defined.
`v2-files boolean`
  If the code was compiled to be able to read V2 configuration files, a false argument to this command will prevent them from being read. This can be useful while testing. The default is true.
`hdb-files boolean`
  If the code was compiled to be able to read HDB configuration files, a false argument to this command will prevent them from being read. This can be useful while testing. The default is true.

### Configuration File Names

`sysfile strings`
  Specify the system file(s). The default is the file ``sys'` in the directory newconfigdir. These files hold information about other systems with which this system communicates; see section The System Configuration File. Multiple system files may be given on the line, and the `sysfile` command may be repeated; each system file has its own set of defaults.
`portfile strings`
  Specify the port file(s). The default is the file ``port'` in the directory newconfigdir. These files describe ports which are used to call other systems and accept calls from other systems; see section The Port Configuration File. No port files need be named at all. Multiple port files may be given on the line, and the `portfile` command may be repeated.
`dialfile strings`
  Specify the dial file(s). The default is the file ``dial'` in the directory newconfigdir. These files describe dialing devices (modems); see section The Dialer Configuration File. No dial files need be named at all. Multiple dial files may be given on the line, and the `dialfile` command may be repeated.
`dialcodefile strings`
  Specify the dialcode file(s). The default is the file ``dialcode'` in the directory newconfigdir. These files specify dialcodes that may be used when sending phone numbers to a modem. This permits using the same set of phone numbers in different area-codes or with different phone systems, by using dialcodes to specify the calling sequence. When a phone number goes through dialcode translation, the leading alphabetic characters are stripped off. The dialcode files are read line by line, just like any other configuration file, and when a line is found whose first word is the same as the leading characters from the phone number, the second word on the line (which would normally consist of numbers) replaces the dialcode in the phone number. No dialcode file need be used. Multiple dialcode files may be specified on the line, and the `dialcodefile` command may be repeated; all the dialcode files will be read in turn until a dialcode is located.
`callfile strings`
  Specify the call out login name and password file(s). The default is the file ``call'` in the directory newconfigdir. If the call out login name or password for a system are given as `*` (see section Logging In), these files are read to get the real login name or password. Each line in the file(s) has three words: the system name, the login name, and the password. The login name and password may contain escape sequences like those in a chat script expect string (see section Chat Scripts). This file is only used when placing calls to remote systems; the password file described under `passwdfile` below is used for incoming calls. The intention of the call out file is to permit the system file to be publically readable; the call out files must obviously be kept secure. These files need not be used. Multiple call out files may be specified on the line, and the `callfile` command may be repeated; all the files will be read in turn until the system is found.
`passwdfile strings`
  Specify the password file(s) to use for login names when `uucico` is doing its own login prompting, which it does when given the ``-e'`, ``-l'` or ``-w'` switches. The default is the file ``passwd'` in the directory newconfigdir. Each line in the file(s) has two words: the login name and the password (e.g., `Ufoo foopas`). They may contain escape sequences like those in a chat script expect string (see section Chat Scripts). The login name is accepted before the system name is known, so these are independent of which system is calling in; a particular login may be required for a system by using the `called-login` command in the system file (see section Accepting a Call). These password files are optional, although one must exist if `uucico` is to present its own login prompts. As a special exception, a colon may be used to separate the login name from the password, and a colon may be used to terminate the password. This means that the login name and password may not contain a colon. This feature, in conjunction with the `HAVE_ENCRYPTED_PASSWORDS` macro in ``policy.h'`, permits using a standard Unix ``/etc/passwd'` as a UUCP password file, providing the same set of login names and passwords for both `getty` and `uucico`. Multiple password files may be specified on the line, and the `passwdfile` command may be repeated; all the files will be read in turn until the login name is found.

### Log File Names

`logfile string`
  Name the log file. The default is from ``policy.h'`. Logging information is written to this file. If `HAVE_HDB_LOGGING` is defined in ``policy.h'`, then by default a separate log file is used for each system; using this command to name a log file will cause all the systems to use it.
`statfile string`
  Name the statistics file. The default is from ``policy.h'`. Statistical information about file transfers is written to this file.
`debugfile string`
  Name the file to which all debugging information is written. The default is from ``policy.h'`. This command is only effective if the code has been compiled to include debugging (this is controlled by the `DEBUG` macro in ``policy.h'`). If debugging is on, messages written to the log file are also written to the debugging file to make it easier to keep the order of actions straight. The debugging file is different from the log file because information such as passwords can appear in it, so it must be not be publically readable.

### Debugging Levels

`debug string ...`
  Set the debugging level. This command is only effective if the code has been compiled to include debugging. The default is to have no debugging. The arguments are strings which name the types of debugging to be turned on. The following types of debugging are defined:
  ``abnormal'`
    Output debugging messages for abnormal situations, such as recoverable errors.
  ``chat'`
    Output debugging messages for chat scripts.
  ``handshake'`
    Output debugging messages for the initial handshake.
  ``uucp-proto'`
    Output debugging messages for the UUCP session protocol.
  ``proto'`
    Output debugging messages for the individual link protocols.
  ``port'`
    Output debugging messages for actions on the communication port.
  ``config'`
    Output debugging messages while reading the configuration files.
  ``spooldir'`
    Output debugging messages for actions in the spool directory.
  ``execute'`
    Output debugging messages whenever another program is executed.
  ``incoming'`
    List all incoming data in the debugging file.
  ``outgoing'`
    List all outgoing data in the debugging file.
  ``all'`
    All of the above.
  The debugging level may also be specified as a number. A 1 will set ``chat'` debugging, a 2 will set both ``chat'` and ``handshake'` debugging, and so on down the possibilities. Currently an 11 will turn on all possible debugging, since there are 11 types of debugging messages listed above; more debugging types may be added in the future. The `debug` command may be used several times in the configuration file; every debugging type named will be turned on. When running any of the programs, the ``-x'` switch (actually, for `uulog` it's the ``-X'` switch) may be used to turn on debugging. The argument to the ``-x'` switch is one of the strings listed above, or a number as described above, or a comma separated list of strings (e.g., ``-x chat,handshake'`). The ``-x'` switch may also appear several times on the command line, in which case all named debugging types will be turned on. The ``-x'` debugging is in addition to any debugging specified by the `debug` command; there is no way to cancel debugging information. The debugging level may also be set specifically for calls to or from a specific system with the `debug` command in the system file (see section Miscellaneous sys File Commands). The debugging messages are somewhat idiosyncratic; it may be necessary to refer to the source code for additional information in some cases.

## The System Configuration File

By default there is a single system configuration, named ``sys'` in the directory newconfigdir. This may be overridden by the `sysfile` command in the main configuration file; see section Configuration File Names.

These files describe all remote systems known to the UUCP package.

- Defaults and Alternates: Using Defaults and Alternates
- Naming the System: Naming the System
- Calling Out: Calling Out
- Accepting a Call: Accepting a Call
- Protocol Selection: Protocol Selection
- File Transfer Control: File Transfer Control
- Miscellaneous (sys): Miscellaneous sys File Commands
- Default sys File Values: Default Values

### Defaults and Alternates

The first set of commands in the file, up to the first `system` command, specify defaults to be used for all systems in that file. Each ``sys'` file uses a different set of defaults.

Subsequently, each set of commands from `system` up to the next `system` command describe a particular system. Default values may be overridden for specific systems.

Each system may then have a series of alternate choices to use when calling out or calling in. The first set of commands for a particular system, up to the first `alternate` command, provide the first choice. Subsequently, each set of commands from `alternate` up to the next `alternate` command describe an alternate choice for calling out or calling in.

When a system is called, the commands before the first `alternate` are used to select a phone number, port, and so forth; if the call fails for some reason, the commands between the first `alternate` and the second are used, and so forth. Well, not quite. Actually, each succeeding alternate will only be used if it is different in some relevant way (different phone number, different chat script, etc.). If you want to force the same alternate to be used again (to retry a phone call more than once, for example), enter the phone number (or any other relevant field) again to make it appear different.

The alternates can also be used to give different permissions to an incoming call based on the login name. This will only be done if the first set of commands, before the first `alternate` command, uses the `called-login` command. The list of alternates will be searched, and the first alternate with a matching `called-login` command will be used. If no alternates match, the call will be rejected.

The `alternate` command may also be used in the file-wide defaults (the set of commands before the first `system` command). This might be used to specify a list of ports which are available for all systems (for an example of this, see section Gateway Example) or to specify permissions based on the login name used by the remote system when it calls in. The first alternate for each system will default to the first alternate for the file-wide defaults (as modified by the commands used before the first `alternate` command for this system), the second alternate for each system to the second alternate for the file-wide defaults (as modified the same way), and so forth. If a system specifies more alternates than the file-wide defaults, the trailing ones will default to the last file-wide default alternate. If a system specifies fewer alternates than the file-wide defaults, the trailing file-wide default alternates will be used unmodified. The `default-alternates` command may be used to modify this behaviour.

This can all get rather confusing, although it's easier to use than to describe concisely; the `uuchk` program may be used to ensure that you are getting what you want.

### Naming the System

`system string`
  Specify the remote system name. Subsequent commands up to the next `system` command refer to this system.
`alternate [string]`
  Start an alternate set of commands (see section Defaults and Alternates). An optional argument may be used to name the alternate. This name will be recorded in the log file if the alternate is used to call the system. There is no way to name the first alternate (the commands before the first `alternate` command).
`default-alternates boolean`
  If the argument is false, any remaining default alternates (from the defaults specified at the top of the current system file) will not be used. The default is true.
`alias string`
  Specify an alias for the current system. The alias may be used by local `uucp` and `uux` commands, as well as by the remote system (which can be convenient if a remote system changes its name). The default is to have no aliases.
`myname string`
  Specifies a different system name to use when calling the remote system. Also, if `called-login` is used and is not ``ANY'`, then, when a system logs in with that login name, string is used as the local system name. Because the local system name must be determined before the remote system has identified itself, using `myname` and `called-login` together for any system will set the local name for that login; this means that each locally used system name must have a unique login name associated with it. This allows a system to have different names for an external and an internal network. The default is to not use a special local name.

### Calling Out

This section describes commands used when placing a call to another system.

- When to Call: When to Call
- Placing the Call: Placing the Call
- Logging In: Logging In

#### When to Call

`time string [number]`
  Specify when the system may be called. The first argument is a time string; see section Time Strings. The optional second argument specifies a retry time in minutes. If a call made during a time that matches the time string fails, no more calls are permitted until the retry time has passed. By default an exponentially increasing retry time is used: after each failure the next retry period is longer. A retry time specified in the `time` command is always a fixed amount of time. The `time` command may appear multiple times in a single alternate, in which case if any time string matches the system may be called. When the `time` command is used for a particular system, any `time` or `timegrade` commands that appeared in the system defaults are ignored. The default time string is ``Never'`.
`timegrade character string [number]`
  The character specifies a grade. It must be a single letter or digit. The string is a time string (see section Time Strings). All jobs of grade character or higher (where `0` > `9` > `A` > `Z` > `a` > `z`) may be run at the specified time. An ordinary `time` command is equivalent to using `timegrade` with a grade of `z`, permitting all jobs. If there are no jobs of a sufficiently high grade according to the time string, the system will not be called. Giving the ``-s'` switch to `uucico` to force it to call a system causes it to assume there is a job of grade `0` waiting to be run. The optional third argument specifies a retry time in minutes. See the `time` command, above, for more details. Note that the `timegrade` command serves two purposes: 1) if there is no job of sufficiently high grade the system will not be called, and 2) if the system is called anyway (because the ``-s'` switch was given to `uucico`) only jobs of sufficiently high grade will be transferred. However, if the other system calls in, the `timegrade` commands are ignored, and jobs of any grade may be transferred (but see `call-timegrade` and `called-timegrade`, below). Also, the `timegrade` command will not prevent the other system from transferring any job it chooses, regardless of who placed the call. The `timegrade` command may appear multiple times without using `alternate`. When the `timegrade` command is used for a particular system, any `time` or `timegrade` commands that appeared in the system defaults are ignored. If this command does not appear, there are no restrictions on what grade of work may be done at what time.
`max-retries number`
  Gives the maximum number of times this system may be retried. If this many calls to the system fail, it will be called at most once a day whatever the retry time is. The default is 26.
`success-wait number`
  A retry time, in seconds, which applies after a successful call. This can be used to put a limit on how frequently the system is called. For example, an argument of 1800 means that the system will not be called more than once every half hour. The default is 0, which means that there is no limit.
`call-timegrade character string`
  The character is a single character `A` to `Z`, `a` to `z`, or `0` to `9` and specifies a grade. The string is a time string (see section Time Strings). If a call is placed to the other system during a time which matches the time string, the remote system will be requested to only run jobs of grade character or higher. Unfortunately, there is no way to guarantee that the other system will obey the request (this UUCP package will, but there are others which will not); moreover, job grades are historically somewhat arbitrary, so specifying a grade will only be meaningful if the other system cooperates in assigning grades. This grade restriction only applies when the other system is called, not when the other system calls in. The `call-timegrade` command may appear multiple times without using `alternate`. If this command does not appear, or if none of the time strings match, the remote system will be allowed to send whatever grades of work it chooses.
`called-timegrade character string`
  The character is a single character `A` to `Z`, `a` to `z`, or `0` to `9` and specifies a grade. The string is a time string (see section Time Strings). If a call is received from the other system during a time which matches the time string, only jobs of grade character or higher will be sent to the remote system. This allows the job grade to be set for incoming calls, overriding any request made by the remote uucico. As noted above, job grades are historically somewhat arbitrary, so specifying a grade will only be meaningful if the other system cooperates in assigning grades. This grade restriction only applies to jobs on the local system; it does not affect the jobs transferred by the remote system. This grade restriction only applies when the other system calls in, not when the other system is called. The `called-timegrade` command may appear multiple times. If this command does not appear, or if none of the time strings match, any grade may be sent to the remote system upon receiving a call.

#### Placing the Call

`speed number`
`baud number`
  Specify the speed (the term baud is technically incorrect, but widely understood) at which to call the system. This will try all available ports with that speed until an unlocked port is found. The ports are defined in the port file. If both `speed` and `port` commands appear, both are used when selecting a port. To allow calls at more than one speed, the `alternate` command must be used (see section Defaults and Alternates). If this command does not appear, there is no default; the speed may be specified in the port file, but if it is not then the natural speed of the port will be used (whatever that means on the system). Specifying an explicit speed of 0 will request the natural speed of the port (whatever the system sets it to), overriding any default speed from the defaults at the top of the file.
`port string`
  Name a particular port or type of port to use when calling the system. The information for this port is obtained from the port file. If this command does not appear, there is no default; a port must somehow be specified in order to call out (it may be specified implicitly using the `speed` command or explicitly using the next version of `port`). There may be many ports with the same name; each will be tried in turn until an unlocked one is found which matches the desired speed.
`port string ...`
  If more than one string follows the `port` command, the strings are treated as a command that might appear in the port file (see section The Port Configuration File). If a port is named (by using a single string following `port`) these commands are ignored; their purpose is to permit defining the port completely in the system file rather than always requiring entries in two different files. In order to call out, a port must be specified using some version of the `port` command, or by using the `speed` command to select ports from the port file.
`phone string`
`address string`
  Give a phone number to call (when using a modem port) or a remote host to contact (when using a TCP or TLI port). The commands `phone` and `address` are equivalent; the duplication is intended to provide a mnemonic choice depending on the type of port in use. When used with a modem port, an `=` character in the phone number means to wait for a secondary dial tone (although only some modems support this); a `-` character means to pause while dialing for 1 second (again, only some modems support this). If the system has more than one phone number, each one must appear in a different alternate. The `phone` command must appear in order to call out on a modem; there is no default. When used with a TCP port, the string names the host to contact. It may be a domain name or a numeric Internet address. If no address is specified, the system name is used. When used with a TLI port, the string is treated as though it were an expect string in a chat script, allowing the use of escape characters (see section Chat Scripts). The `dialer-sequence` command in the port file may override this address (see section The Port Configuration File). When used with a port that not a modem or TCP or TLI, this command is ignored.

#### Logging In

`chat strings`
`chat-timeout number`
`chat-fail string`
`chat-seven-bit boolean`
`chat-program strings`
  These commands describe a chat script to use when logging on to a remote system. This login chat script is run after any chat script defined in the ``dial'` file (see section The Dialer Configuration File). Chat scripts are explained in section Chat Scripts. Two additional escape sequences may be used in send strings.
  ``\L'`
    Send the login name, as set by the `call-login` command.
  ``\P'`
    Send the password, as set by the `call-password` command.
  Three additional escape sequences may be used with the `chat-program` command. These are ``\L'` and ``\P'`, which become the login name and password, respectively, and ``\Z'`, which becomes the name of the system of being called. The default chat script is:

      chat "" \r\c ogin:-BREAK-ogin:-BREAK-ogin: \L word: \P

  This will send a carriage return (the `\c` suppresses the additional trailing carriage return that would otherwise be sent) and waits for the string ``ogin:'` (which would be the last part of the ``login:'` prompt supplied by a Unix system). If it doesn't see ``ogin:'`, it sends a break and waits for ``ogin:'` again. If it still doesn't see ``ogin:'`, it sends another break and waits for ``ogin:'` again. If it still doesn't see ``ogin:'`, the chat script aborts and hangs up the phone. If it does see ``ogin:'` at some point, it sends the login name (as specified by the `call-login` command) followed by a carriage return (since all send strings are followed by a carriage return unless `\c` is used) and waits for the string ``word:'` (which would be the last part of the ``Password:'` prompt supplied by a Unix system). If it sees ``word:'`, it sends the password and a carriage return, completing the chat script. The program will then enter the handshake phase of the UUCP protocol. This chat script will work for most systems, so you will only be required to use the `call-login` and `call-password` commands. In fact, in the file-wide defaults you could set defaults of ``call-login *'` and ``call-password *'`; you would then just have to make an entry for each system in the call-out login file. Some systems seem to flush input after the ``login:'` prompt, so they may need a version of this chat script with a `\d` before the `\L`. When using UUCP over TCP, some servers will not be handle the initial carriage return sent by this chat script; in this case you may have to specify the simple chat script ``ogin: \L word: \P'`.
`call-login string`
  Specify the login name to send with `\L` in the chat script. If the string is ``*'` (e.g., ``call-login *'`) the login name will be fetched from the call out login name and password file (see section Configuration File Names). The string may contain escape sequences as though it were an expect string in a chat script (see section Chat Scripts). There is no default.
`call-password string`
  Specify the password to send with `\P` in the chat script. If the string is ``*'` (e.g., ``call-password *'`) the password will be fetched from the call-out login name and password file (see section Configuration File Names). The string may contain escape sequences as though it were an expect string in a chat script (see section Chat Scripts). There is no default.

### Accepting a Call

`called-login strings`
  The first string specifies the login name that the system must use when calling in. If it is ``ANY'` (e.g., ``called-login ANY'`) any login name may be used; this is useful to override a file-wide default and to indicate that future alternates may have different login names. Case is significant. The default value is ``ANY'`. Different alternates (see section Defaults and Alternates) may use different `called-login` commands, in which case the login name will be used to select which alternate is in effect; this will only work if the first alternate (before the first `alternate` command) uses the `called-login` command. Additional strings may be specified after the login name; they are a list of which systems are permitted to use this login name. If this feature is used, then normally the login name will only be given in a single `called-login` command. Only systems which appear on the list, or which use an explicit `called-login` command, will be permitted to use that login name. If the same login name is used more than once with a list of systems, all the lists are concatenated together. This feature permits you to restrict a login name to a particular set of systems without requiring you to use the `called-login` command for every single system; you can achieve a similar effect by using a different system file for each permitted login name with an appropriate `called-login` command in the file-wide defaults.
`callback boolean`
  If boolean is true, then when the remote system calls `uucico` will hang up the connection and prepare to call it back. The default is false.
`called-chat strings`
`called-chat-timeout number`
`called-chat-fail string`
`called-chat-seven-bit boolean`
`called-chat-program strings`
  These commands may be used to define a chat script (see section Chat Scripts) that is run whenever the local system is called by the system being defined. The chat script defined by the `chat` command (see section Logging In), on the other hand, is used when the remote system is called. This called chat script might be used to set special modem parameters that are appropriate to a particular system. It is run after protocol negotiation is complete, but before the protocol has been started. For additional escape sequence which may be used besides those defined for all chat scripts, see section Logging In. There is no default called chat script. If the called chat script fails, the incoming call will be aborted.

### Protocol Selection

`protocol string`
  Specifies which protocols to use for the other system, and in which order to use them. This would not normally be used. For example, ``protocol tfg'`. The default depends on the characteristics of the port and the dialer, as specified by the `seven-bit` and `reliable` commands. If neither the port nor the dialer use either of these commands, the default is to assume an eight-bit reliable connection. The commands ``seven-bit true'` or ``reliable false'` might be used in either the port or the dialer to change this. Each protocol has particular requirements that must be met before it will be considered during negotiation with the remote side. The ``t'` and ``e'` protocols are intended for use over TCP or some other communication path with end to end reliability, as they do no checking of the data at all. They will only be considered on a TCP port which is both reliable and eight bit. For technical details, see section UUCP ``t'` Protocol, and section UUCP ``e'` Protocol. The ``i'` protocol is a bidirectional protocol. It requires an eight-bit connection. It will run over a half-duplex link, such as Telebit modems in PEP mode, but for efficient use of such a connection you must use the `half-duplex` command (see section The Port Configuration File). See section UUCP ``i'` Protocol. The ``g'` protocol is robust, but requires an eight-bit connection. See section UUCP ``g'` Protocol. The ``G'` protocol is the System V Release 4 version of the ``g'` protocol. See section UUCP ``G'` Protocol. The ``a'` protocol is a Zmodem like protocol, contributed by Doug Evans. It requires an eight-bit connection, but unlike the ``g'` or ``i'` protocol it will work if certain control characters may not be transmitted. The ``j'` protocol is a variant of the ``i'` protocol which can avoid certain control characters. The set of characters it avoids can be set by a parameter. While it technically does not require an eight bit connection (it could be configured to avoid all characters with the high bit set) it would be very inefficient to use it over one. It is useful over a eight-bit connection that will not transmit certain control characters. See section UUCP ``j'` Protocol. The ``f'` protocol is intended for use with X.25 connections; it checksums each file as a whole, so any error causes the entire file to be retransmitted. It requires a reliable connection, but only uses seven-bit transmissions. It is a streaming protocol, so, while it can be used on a serial port, the port must be completely reliable and flow controlled; many aren't. See section UUCP ``f'` Protocol. The ``v'` protocol is the ``g'` protocol as used by the DOS program UUPC/Extended. It is provided only so that UUPC/Extended users can use it; there is no particular reason to select it. See section UUCP ``v'` Protocol. The ``y'` protocol is an efficient streaming protocol. It does error checking, but when it detects an error it immediately aborts the connection. This requires a reliable, flow controlled, eight-bit connection. In practice, it is only useful on a connection that is nearly always error-free. Unlike the ``t'` and ``e'` protocols, the connection need not be entirely error-free, so the ``y'` protocol can be used on a serial port. See section UUCP ``y'` Protocol. The protocols will be considered in the order shown above. This means that if neither the `seven-bit` nor the `reliable` command are used, the ``t'` protocol will be used over a TCP connection and the ``i'` protocol will be used over any other type of connection (subject, of course, to what is supported by the remote system; it may be assumed that all systems support the ``g'` protocol). Note that currently specifying both ``seven-bit true'` and ``reliable false'` will not match any protocol. If this occurs through a combination of port and dialer specifications, you will have to use the `protocol` command for the system or no protocol will be selected at all (the only reasonable choice would be ``protocol f'`). A protocol list may also be specified for a port (see section The Port Configuration File), but, if there is a list for the system, the list for the port is ignored.
`protocol-parameter character string ...`
  character is a single character specifying a protocol. The remaining strings are a command specific to that protocol which will be executed if that protocol is used. A typical command is something like ``window 7'`. The particular commands are protocol specific. The ``i'` protocol supports the following commands, all of which take numeric arguments:
  `window`
    The window size to request the remote system to use. This must be between 1 and 16 inclusive. The default is 16.
  `packet-size`
    The packet size to request the remote system to use. This must be between 1 and 4095 inclusive. The default is 1024.
  `remote-packet-size`
    If this is between 1 and 4095 inclusive, the packet size requested by the remote system is ignored, and this is used instead. The default is 0, which means that the remote system's request is honored.
  `sync-timeout`
    The length of time, in seconds, to wait for a SYNC packet from the remote system. SYNC packets are exchanged when the protocol is started. The default is 10.
  `sync-retries`
    The number of times to retry sending a SYNC packet before giving up. The default is 6.
  `timeout`
    The length of time, in seconds, to wait for an incoming packet before sending a negative acknowledgement. The default is 10.
  `retries`
    The number of times to retry sending a packet or a negative acknowledgement before giving up and closing the connection. The default is 6.
  `errors`
    The maximum number of errors to permit before closing the connection. The default is 100.
  `error-decay`
    The rate at which to ignore errors. Each time this many packets are received, the error count is decreased by one, so that a long connection with an occasional error will not exceed the limit set by `errors`. The default is 10.
  `ack-frequency`
    The number of packets to receive before sending an acknowledgement. The default is half the requested window size, which should provide good performance in most cases.
  The ``g'`, ``G'` and ``v'` protocols support the following commands, all of which take numeric arguments, except `short-packets` which takes a boolean argument:
  `window`
    The window size to request the remote system to use. This must be between 1 and 7 inclusive. The default is 7.
  `packet-size`
    The packet size to request the remote system to use. This must be a power of 2 between 32 and 4096 inclusive. The default is 64 for the ``g'` and ``G'` protocols and 1024 for the ``v'` protocol. Many older UUCP packages do not support packet sizes larger than 64, and many others do not support packet sizes larger than 128. Some UUCP packages will even dump core if a larger packet size is requested. The packet size is not a negotiation, and it may be different in each direction. If you request a packet size larger than the remote system supports, you will not be able to send any files.
  `startup-retries`
    The number of times to retry the initialization sequence. The default is 8.
  `init-retries`
    The number of times to retry one phase of the initialization sequence (there are three phases). The default is 4.
  `init-timeout`
    The timeout in seconds for one phase of the initialization sequence. The default is 10.
  `retries`
    The number of times to retry sending either a data packet or a request for the next packet. The default is 6.
  `timeout`
    The timeout in seconds when waiting for either a data packet or an acknowledgement. The default is 10.
  `garbage`
    The number of unrecognized bytes to permit before dropping the connection. This must be larger than the packet size. The default is 10000.
  `errors`
    The number of errors (malformed packets, out of order packets, bad checksums, or packets rejected by the remote system) to permit before dropping the connection. The default is 100.
  `error-decay`
    The rate at which to ignore errors. Each time this many packets are received, the error count is decreased by one, so that a long connection with an occasional error will not exceed the limit set by `errors`. The default is 10.
  `remote-window`
    If this is between 1 and 7 inclusive, the window size requested by the remote system is ignored and this is used instead. This can be useful when dealing with some poor UUCP packages. The default is 0, which means that the remote system's request is honored.
  `remote-packet-size`
    If this is between 32 and 4096 inclusive the packet size requested by the remote system is ignored and this is used instead. There is probably no good reason to use this. The default is 0, which means that the remote system's request is honored.
  `short-packets`
    If this is true, then the code will optimize by sending shorter packets when there is less data to send. This confuses some UUCP packages, such as System V Release 4 (when using the ``G'` protocol) and Waffle; when connecting to such a package, this parameter must be set to false. The default is true for the ``g'` and ``v'` protocols and false for the ``G'` protocol.
  The ``a'` protocol is a Zmodem like protocol contributed by Doug Evans. It supports the following commands, all of which take numeric arguments except for `escape-control`, which takes a boolean argument:
  `timeout`
    Number of seconds to wait for a packet to arrive. The default is 10.
  `retries`
    The number of times to retry sending a packet. The default is 10.
  `startup-retries`
    The number of times to retry sending the initialization packet. The default is 4.
  `garbage`
    The number of garbage characters to accept before closing the connection. The default is 2400.
  `send-window`
    The number of characters that may be sent before waiting for an acknowledgement. The default is 1024.
  `escape-control`
    Whether to escape control characters. If this is true, the protocol may be used over a connection which does not transmit certain control characters, such as `XON` or `XOFF`. The connection must still transmit eight bit characters other than control characters. The default is false.
  The ``j'` protocol can be used over an eight bit connection that will not transmit certain control characters. It accepts the same protocol parameters that the ``i'` protocol accepts, as well as one more:
  `avoid`
    A list of characters to avoid. This is a string which is interpreted as an escape sequence (see section Chat Scripts). The protocol does not have a way to avoid printable ASCII characters (byte values from 32 to 126, inclusive); only ASCII control characters and eight-bit characters may be avoided. The default value is ``\021\023'`; these are the characters `XON` and `XOFF`, which many connections use for flow control. If the package is configured to use `HAVE_BSD_TTY`, then on some versions of Unix you may have to avoid ``\377'` as well, due to the way some implementations of the BSD terminal driver handle signals.
  The ``f'` protocol is intended for use with error-correcting modems only; it checksums each file as a whole, so any error causes the entire file to be retransmitted. It supports the following commands, both of which take numeric arguments:
  `timeout`
    The timeout in seconds before giving up. The default is 120.
  `retries`
    How many times to retry sending a file. The default is 2.
  The ``t'` and ``e'` protocols are intended for use over TCP or some other communication path with end to end reliability, as they do no checking of the data at all. They both support a single command, which takes a numeric argument:
  `timeout`
    The timeout in seconds before giving up. The default is 120.
  The ``y'` protocol is a streaming protocol contributed by Jorge Cwik. It supports the following commands, both of which take numeric arguments:
  `timeout`
    The timeout in seconds when waiting for a packet. The default is 60.
  `packet-size`
    The packet size to use. The default is 1024.
  The protocol parameters are reset to their default values after each call.

### File Transfer Control

`send-request boolean`
  The boolean determines whether the remote system is permitted to request files from the local system. The default is yes.
`receive-request boolean`
  The boolean determines whether the remote system is permitted to send files to the local system. The default is yes.
`request boolean`
  A shorthand command, equivalent to specifying both ``send-request boolean'` and ``receive-request boolean'`.
`call-transfer boolean`
  The boolean is checked when the local system places the call. It determines whether the local system may do file transfers queued up for the remote system. The default is yes.
`called-transfer boolean`
  The boolean is checked when the remote system calls in. It determines whether the local system may do file transfers queued up for the remote system. The default is yes.
`transfer boolean`
  A shorthand command, equivalent to specifying both ``call-transfer boolean'` and ``called-transfer boolean'`.
`call-local-size number string`
  The string is a time string (see section Time Strings). The number is the size in bytes of the largest file that should be transferred at a time matching the time string, if the local system placed the call and the request was made by the local system. This command may appear multiple times in a single alternate. If this command does not appear, or if none of the time strings match, there are no size restrictions. With all the size control commands, the size of a file from the remote system (as opposed to a file from the local system) will only be checked if the other system is running this package: other UUCP packages will not understand a maximum size request, nor will they provide the size of remote files.
`call-remote-size number string`
  Specify the size in bytes of the largest file that should be transferred at a given time by remote request, when the local system placed the call. This command may appear multiple times in a single alternate. If this command does not appear, there are no size restrictions.
`called-local-size number string`
  Specify the size in bytes of the largest file that should be transferred at a given time by local request, when the remote system placed the call. This command may appear multiple times in a single alternate. If this command does not appear, there are no size restrictions.
`called-remote-size number string`
  Specify the size in bytes of the largest file that should be transferred at a given time by remote request, when the remote system placed the call. This command may appear multiple times in a single alternate. If this command does not appear, there are no size restrictions.
`local-send strings`
  Specifies that files in the directories named by the strings may be sent to the remote system when requested locally (using `uucp` or `uux`). The directories in the list should be separated by whitespace. A ``~'` may be used for the public directory. On a Unix system, this is typically ``/usr/spool/uucppublic'`; the public directory may be set with the `pubdir` command. Here is an example of `local-send`:

      local-send ~ /usr/spool/ftp/pub

  Listing a directory allows all files within the directory and all subdirectories to be sent. Directories may be excluded by preceding them with an exclamation point. For example:

      local-send /usr/ftp !/usr/ftp/private ~

  means that all files in ``/usr/ftp'` or the public directory may be sent, except those files in ``/usr/ftp/private'`. The list of directories is read from left to right, and the last directory to apply takes effect; this means that directories should be listed from top down. The default is the root directory (i.e., any file at all may be sent by local request).
`remote-send strings`
  Specifies that files in the named directories may be sent to the remote system when requested by the remote system. The default is ``~'`.
`local-receive strings`
  Specifies that files may be received into the named directories when requested by a local user. The default is ``~'`.
`remote-receive strings`
  Specifies that files may be received into the named directories when requested by the remote system. The default is ``~'`. On Unix, the remote system may only request that files be received into directories that are writeable by the world, regardless of how this is set.
`forward-to strings`
  Specifies a list of systems to which files may be forwarded. The remote system may forward files through the local system on to any of the systems in this list. The string ``ANY'` may be used to permit forwarding to any system. The default is to not permit forwarding to other systems. Note that if the remote system is permitted to execute the `uucp` command, it effectively has the ability to forward to any system.
`forward-from strings`
  Specifies a list of systems from which files may be forwarded. The remote system may request files via the local system from any of the systems in this list. The string ``ANY'` may be used to permit forwarding to any system. The default is to not permit forwarding from other systems. Note that if a remote system is permitted to execute the `uucp` command, it effectively has the ability to request files from any system.
`forward strings`
  Equivalent to specifying both ``forward-to strings'` and ``forward-from strings'`. This would normally be used rather than either of the more specific commands.

### Miscellaneous sys File Commands

`sequence boolean`
  If boolean is true, then conversation sequencing is automatically used for the remote system, so that if somebody manages to spoof as the remote system, it will be detected the next time the remote system actually calls. This is false by default.
`command-path strings`
  Specifies the path (a list of whitespace separated directories) to be searched to locate commands to execute. This is only used for commands requested by `uux`, not for chat programs. The default is from ``policy.h'`.
`commands strings`
  The list of commands which the remote system is permitted to execute locally. For example: ``commands rnews rmail'`. If the value is ``ALL'` (case significant), all commands may be executed. The default is ``rnews rmail'`.
`free-space number`
  Specify the minimum amount of file system space (in bytes) to leave free after receiving a file. If the incoming file will not fit, it will be rejected. This initial rejection will only work when talking to another instance of this package, since older UUCP packages do not provide the file size of incoming files. Also, while a file is being received, `uucico` will periodically check the amount of free space. If it drops below the amount given by the `free-space` command, the file transfer will be aborted. The default amount of space to leave free is from ``policy.h'`. This file space checking may not work on all systems.
`pubdir string`
  Specifies the public directory that is used when ``~'` is specifed in a file transfer or a list of directories. This essentially overrides the public directory specified in the main configuration file for this system only. The default is the public directory specified in the main configuration file (which defaults to a value from ``policy.h'`).
`debug string ...`
  Set additional debugging for calls to or from the system. This may be used to debug a connection with a specific system. It is particularly useful when debugging incoming calls, since debugging information will be generated whenever the call comes in. See the `debug` command in the main configuration file (see section Debugging Levels) for more details. The debugging information specified here is in addition to that specified in the main configuration file or on the command line.
`max-remote-debug string ...`
  When the system calls in, it may request that the debugging level be set to a certain value. The `max-remote-debug` command may be used to put a limit on the debugging level which the system may request, to avoid filling up the disk with debugging information. Only the debugging types named in the `max-remote-debug` command may be turned on by the remote system. To prohibit any debugging, use ``max-remote-debug none'`.

### Default sys File Values

The following are used as default values for all systems; they can be considered as appearing before the start of the file.

    time Never
    chat "" \r\c ogin:-BREAK-ogin:-BREAK-ogin: \L word: \P
    chat-timeout 10
    callback n
    sequence n
    request y
    transfer y
    local-send /
    remote-send ~
    local-receive ~
    remove-receive ~
    command-path [ from `policy.h' ]
    commands rnews rmail
    max-remote-debug abnormal,chat,handshake

## The Port Configuration File

The port files may be used to name and describe ports. By default there is a single port file, named ``port'` in the directory newconfigdir. This may be overridden by the `portfile` command in the main configuration file; see section Configuration File Names.

Any commands in a port file before the first `port` command specify defaults for all ports in the file; however, since the `type` command must appear before all other commands for a port, the defaults are only useful if all ports in the file are of the same type (this restriction may be lifted in a later version). All commands after a `port` command up to the next `port` command then describe that port. There are different types of ports; each type supports its own set of commands. Each command indicates which types of ports support it. There may be many ports with the same name; if a system requests a port by name then each port with that name will be tried until an unlocked one is found.

`port string`
  Introduces and names a port.
`type string`
  Define the type of port. The default is ``modem'`. If this command appears, it must immediately follow the `port` command. The type defines what commands are subsequently allowed. Currently the types are:
  ``modem'`
    For a modem hookup.
  ``stdin'`
    For a connection through standard input and standard output, as when `uucico` is run as a login shell.
  ``direct'`
    For a direct connection to another system.
  ``tcp'`
    For a connection using TCP.
  ``tli'`
    For a connection using TLI.
  ``pipe'`
    For a connection through a pipe running another program.
`protocol string`
  Specify a list of protocols to use for this port. This is just like the corresponding command for a system (see section Protocol Selection). A protocol list for a system takes precedence over a list for a port.
`protocol-parameter character strings [ any type ]`
  The same command as the `protocol-parameter` command used for systems (see section Protocol Selection). This one takes precedence.
`seven-bit boolean [ any type ]`
  This is only used during protocol negotiation; if the argument is true, it forces the selection of a protocol which works across a seven-bit link. It does not prevent eight bit characters from being transmitted. The default is false.
`reliable boolean [ any type ]`
  This is only used during protocol negotiation; if the argument is false, it forces the selection of a protocol which works across an unreliable communication link. The default is true. It would be more common to specify this for a dialer rather than a port.
`half-duplex boolean [ any type ]`
  If the argument is true, it means that the port only supports half-duplex connections. This only affects bidirectional protocols, and causes them to not do bidirectional transfers.
`device string [ modem, direct and tli only ]`
  Names the device associated with this port. If the device is not named, the port name is taken as the device. Device names are system dependent. On Unix, a modem or direct connection might be something like ``/dev/ttyd0'`; a TLI port might be ``/dev/inet/tcp'`.
`speed number [modem and direct only ]`
`baud number [ modem and direct only ]`
  The speed this port runs at. If a system specifies a speed but no port name, then all ports which match the speed will be tried in order. If the speed is not specified here and is not specified by the system, the natural speed of the port will be used by default.
`speed-range number number [ modem only ]`
`baud-range number number [ modem only ]`
  Specify a range of speeds this port can run at. The first number is the minimum speed, the second number is the maximum speed. These numbers will be used when matching a system which specifies a desired speed. The simple `speed` (or `baud`) command is still used to determine the speed to run at if the system does not specify a speed. For example, the command ``speed-range 300 19200'` means that the port will match any system which uses a speed from 300 to 19200 baud (and will use the speed specified by the system); this could be combined with ``speed 2400'`, which means that when this port is used with a system that does not specify a speed, the port will be used at 2400 baud.
`carrier boolean [ modem and direct only ]`
  The argument indicates whether the port supports carrier. If a modem port does not support carrier, the carrier detect signal will never be required on this port, regardless of what the modem chat script indicates. The default for a modem port is true. If a direct port supports carrier, the port will be set to expect carrier whenever it is used. The default for a direct port is false.
`hardflow boolean [ modem and direct only ]`
  The argument indicates whether the port supports hardware flow control. If it does not, hardware flow control will not be turned on for this port. The default is true. Hardware flow control is only supported on some systems.
`dial-device string [ modem only ]`
  Dialing instructions should be output to the named device, rather than to the normal port device. The default is to output to the normal port device.
`dialer string [ modem only ]`
  Name a dialer to use. The information is looked up in the dial file. There is no default. Some sort of dialer information must be specified to call out on a modem.
`dialer string ... [ modem only ]`
  If more than one string follows the `dialer` command, the strings are treated as a command that might appear in the dial file (see section The Dialer Configuration File). If a dialer is named (by using the first form of this command, described just above), these commands are ignored. They may be used to specify dialer information directly in simple situations without needing to go to a separate file. There is no default. Some sort of dialer information must be specified to call out on a modem.
`dialer-sequence strings [ modem or tcp or tli only ]`
  Name a sequence of dialers and tokens (phone numbers) to use. The first argument names a dialer, and the second argument names a token. The third argument names another dialer, and so on. If there are an odd number of arguments, the phone number specified with a `phone` command in the system file is used as the final token. The token is what is used for `\D` or `\T` in the dialer chat script. If the token in this string is `\D`, the system phone number will be used; if it is `\T`, the system phone number will be used after undergoing dialcodes translation. A missing final token is taken as `\D`. This command currently does not work if `dial-device` is specified; to handle this correctly will require a more systematic notion of chat scripts. Moreover, the `complete` and `abort` chat scripts, the protocol parameters, and the `carrier` and `dtr-toggle` commands are ignored for all but the first dialer. This command basically lets you specify a sequence of chat scripts to use. For example, the first dialer might get you to a local network and the second dialer might describe how to select a machine from the local network. This lets you break your dialing sequence into simple modules, and may make it easier to share dialer entries between machines. This command is to only way to use a chat script with a TCP port. This can be useful when using a modem which is accessed via TCP. When this command is used with a TLI port, then if the first dialer is ``TLI'` or ``TLIS'` the first token is used as the address to connect to. If the first dialer is something else, or if there is no token, the address given by the `address` command is used (see section Placing the Call). Escape sequences in the address are expanded as they are for chat script expect strings (see section Chat Scripts). The different between ``TLI'` and ``TLIS'` is that the latter implies the command ``stream true'`. These contortions are all for HDB compatibility. Any subsequent dialers are treated as they are for a TCP port.
`lockname string [ modem and direct only ]`
  Give the name to use when locking this port. On Unix, this is the name of the file that will be created in the lock directory. It is used as is, so on Unix it should generally start with ``LCK..'`. For example, if a single port were named both ``/dev/ttycu0'` and ``/dev/tty0'` (perhaps with different characteristics keyed on the minor device number), then the command `lockname LCK..ttycu0` could be used to force the latter to use the same lock file name as the former.
`service string [ tcp only ]`
  Name the TCP port number to use. This may be a number. If not, it will be looked up in ``/etc/services'`. If this is not specified, the string ``uucp'` is looked up in ``/etc/services'`. If it is not found, port number 540 (the standard UUCP-over-TCP port number) will be used.
`push strings [ tli only ]`
  Give a list of modules to push on to the TLI stream.
`stream boolean [ tli only ]`
  If this is true, and the `push` command was not used, the ``tirdwr'` module is pushed on to the TLI stream.
`server-address string [ tli only ]`
  Give the address to use when running as a TLI server. Escape sequences in the address are expanded as they are for chat script expect strings (see section Chat Scripts). The string is passed directly to the TLI `t_bind` function. The value needed may depend upon your particular TLI implementation. Check the manual pages, and, if necessary, try writing some sample programs. For AT&T 3B2 System V Release 3 using the Wollongong TCP/IP stack, which is probably typical, the format of TLI string is ``SSPPIIII'`, where ``SS'` is the service number (for TCP, this is 2), ``PP'` is the TCP port number, and ``IIII'` is the Internet address. For example, to accept a connection from on port 540 from any interface, use ``server-address \x00\x02\x02\x1c\x00\x00\x00\x00'`. To only accept connections from a particular interface, replace the last four digits with the network address of the interface. (Thanks to Paul Pryor for the information in this paragraph).
`command strings [ pipe only ]`
  Give the command, with arguments, to run when using a pipe port type. When a port of this type is used, the command is executed and `uucico` communicates with it over a pipe. This permits `uucico` or `cu` to communicate with another system which can only be reached through some unusual means. A sample use might be ``command /bin/rlogin -E -8 -l login system'`. The command is run with the full privileges of UUCP; it is responsible for maintaining security.

## The Dialer Configuration File

The dialer configuration files define dialers. By default there is a single dialer file, named ``dial'` in the directory newconfigdir. This may be overridden by the `dialfile` command in the main configuration file; see section Configuration File Names.

Any commands in the file before the first `dialer` command specify defaults for all the dialers in the file. All commands after a `dialer` command up to the next `dialer` command are associated with the named dialer.

`dialer string`
  Introduces and names a dialer.
`chat strings`
`chat-timeout number`
`chat-fail string`
`chat-seven-bit boolean`
`chat-program strings`
  Specify a chat script to be used to dial the phone. This chat script is used before the login chat script in the ``sys'` file, if any (see section Logging In). For full details on chat scripts, see section Chat Scripts. The `uucico` daemon will sleep for one second between attempts to dial out on a modem. If your modem requires a longer wait period, you must start your chat script with delays (``\d'` in a send string). The chat script will be read from and sent to the port specified by the `dial-device` command for the port, if there is one. The following escape addition escape sequences may appear in send strings:
  `\D`
    send phone number without dialcode translation
  `\T`
    send phone number with dialcode translation
  `\M`
    do not require carrier
  `\m`
    require carrier (fail if not present)
  See the description of the dialcodes file (see section Configuration File Names) for a description of dialcode translation. If the port does not support carrier, as set by the `carrier` command in the port file, `\M` and `\m` are ignored. If both the port and the dialer support carrier, as set by the `carrier` command in the port file and the `carrier` command in the dialer file, then every chat script implicitly begins with `\M` and ends with `\m`. There is no default chat script for dialers. The following additional escape sequences may be used in `chat-program`:
  `\D`
    phone number without dialcode translation
  `\T`
    phone number with dialcode translation
  If the program changes the port in any way (e.g., sets parity) the changes will be preserved during protocol negotiation, but once the protocol is selected it will change the port settings.
`dialtone string`
  A string to output when dialing the phone number which causes the modem to wait for a secondary dial tone. This is used to translate the `=` character in a phone number. The default is a comma.
`pause string`
  A string to output when dialing the phone number which causes the modem to wait for 1 second. This is used to translate the `-` character in a phone number. The default is a comma.
`carrier boolean`
  An argument of true means that the dialer supports the modem carrier signal. After the phone number is dialed, `uucico` will require that carrier be on. One some systems, it will be able to wait for it. If the argument is false, carrier will not be required. The default is true.
`carrier-wait number`
  If the port is supposed to wait for carrier, this may be used to indicate how many seconds to wait. The default is 60 seconds. Only some systems support waiting for carrier.
`dtr-toggle boolean boolean`
  If the first argument is true, then DTR is toggled before using the modem. This is only supported on some systems and some ports. The second boolean need not be present; if it is, and it is true, the program will sleep for 1 second after toggling DTR. The default is to not toggle DTR.
`complete-chat strings`
`complete-chat-timeout number`
`complete-chat-fail string`
`complete-chat-seven-bit boolean`
`complete-chat-program strings`
  These commands define a chat script (see section Chat Scripts) which is run when a call is finished normally. This allows the modem to be reset. There is no default. No additional escape sequences may be used.
`complete string`
  This is a simple use of `complete-chat`. It is equivalent to `complete-chat "" string`; this has the effect of sending string to the modem when a call finishes normally.
`abort-chat strings`
`abort-chat-timeout number`
`abort-chat-fail string`
`abort-chat-seven-bit boolean`
`abort-chat-program strings`
  These commands define a chat script (see section Chat Scripts) to be run when a call is aborted. They may be used to interrupt and reset the modem. There is no default. No additional escape sequences may be used.
`abort string`
  This is a simple use of `abort-chat`. It is equivalent to `abort-chat "" string`; this has the effect of sending string to the modem when a call is aborted.
`protocol-parameter character strings`
  Set protocol parameters, just like the `protocol-parameter` command in the system configuration file or the port configuration file; see section Protocol Selection. These parameters take precedence, then those for the port, then those for the system.
`seven-bit boolean`
  This is only used during protocol negotiation; if it is true, it forces selection of a protocol which works across a seven-bit link. It does not prevent eight bit characters from being transmitted. The default is false. It would be more common to specify this for a port than for a dialer.
`reliable boolean`
  This is only used during protocol negotiation; if it is false, it forces selection of a protocol which works across an unreliable communication link. The default is true.
`half-duplex boolean [ any type ]`
  If the argument is true, it means that the dialer only supports half-duplex connections. This only affects bidirectional protocols, and causes them to not do bidirectional transfers.

## UUCP Over TCP

If your system has a Berkeley style socket library, or a System V style TLI interface library, you can compile the code to permit making connections over TCP. Specifying that a system should be reached via TCP is easy, but nonobvious.

- TCP Client: Connecting to Another System Over TCP
- TCP Server: Running a TCP Server

### Connecting to Another System Over TCP

If you are using the new style configuration files (see section Taylor UUCP Configuration Files), add the line ``port type tcp'` to the entry in the ``sys'` file. By default UUCP will get the port number by looking up ``uucp'` in ``/etc/services'`; if the ``uucp'` service is not defined, port 540 will be used. You can set the port number to use with the command ``port service xxx'`, where xxx can be either a number or a name to look up in ``/etc/services'`. You can specify the address of the remote host with ``address a.b.c'`; if you don't give an address, the remote system name will be used. You should give an explicit chat script for the system when you use TCP; the default chat script begins with a carriage return, which will not work with some UUCP TCP servers.

If you are using V2 configuration files, add a line like this to ``L.sys'`:

    sys Any TCP uucp host.domain chat-script

This will make an entry for system sys, to be called at any time, over TCP, using port number ``uucp'` (as found in ``/etc/services'`; this may be specified as a number), using remote host ``host.domain'`, with some chat script.

If you are using HDB configuration files, add a line like this to Systems:

    sys Any TCP - host.domain chat-script

and a line like this to ``Devices'`:

    TCP uucp - -

You only need one line in ``Devices'` regardless of how many systems you contact over TCP. This will make an entry for system sys, to be called at any time, over TCP, using port number ``uucp'` (as found in ``/etc/services'`; this may be specified as a number), using remote host ``host.domain'`, with some chat script.

### Running a TCP Server

The `uucico` daemon may be run as a TCP server. To use the default port number, which is a reserved port, `uucico` must be invoked by the superuser (or it must be set user ID to the superuser, but I don't recommend doing that).

You must define a port, either using the port file (see section The Port Configuration File), if you are using the new configuration method, or with an entry in ``Devices'` if you are using HDB; there is no way to define a port using V2. If you are using HDB the port must be named ``TCP'`; a line as shown above will suffice. You can then start `uucico` as ``uucico -p TCP'` (after the ``-p'`, name the port; in HDB it must be ``TCP'`). This will wait for incoming connections, and fork off a child for each one. Each connection will be prompted with ``login:'` and ``Password:'`; the results will be checked against the UUCP (not the system) password file (see section Configuration File Names).

Another way to run a UUCP TCP server is to use the BSD `uucpd` program.

Yet another way to run a UUCP TCP server is to use `inetd`. Arrange for `inetd` to start up `uucico` with the ``-l'` switch. This will cause `uucico` to prompt with ``login:'` and ``Password:'` and check the results against the UUCP (not the system) password file (you may want to also use the ``-D'` switch to avoid a fork, which in this case is unnecessary).

## Security

This discussion of UUCP security applies only to Unix. It is a bit cursory; suggestions for improvement are solicited.

UUCP is traditionally not very secure. Taylor UUCP addresses some security issues, but is still far from being a secure system.

If security is very important to you, then you should not permit any external access to your computer, including UUCP. Any opening to the outside world is a potential security risk.

When local users use UUCP to transfer files, Taylor UUCP can do little to secure them from each other. You can allow somewhat increased security by putting the owner of the UUCP programs (normally `uucp`) into a separate group; the use of this is explained in the following paragraphs, which refer to this separate group as `uucp-group`.

When the `uucp` program is invoked to copy a file to a remote system, it will, by default, copy the file into the UUCP spool directory. When the `uux` program is used, the ``-C'` switch must be used to copy the file into the UUCP spool directory. In any case, once the file has been copied into the spool directory, other local users will not be able to access it.

When a file is requested from a remote system, UUCP will only permit it to be placed in a directory which is writable by the requesting user. The directory must also be writable by UUCP. A local user can create a directory with a group of `uucp-group` and set the mode to permit group write access. This will allow the file be requested without permitting it to be viewed by any other user.

There is no provision for security for `uucp` requests (as opposed to `uux` requests) made by a user on a remote system. A file sent over by a remote request may only be placed in a directory which is world writable, and the file will be world readable and writable. This will permit any local user to destroy or replace the contents of the file. A file requested by a remote system must be world readable, and the directory it is in must be world readable. Any local user will be able to examine, although not necessarily modify, the file before it is sent.

There are some security holes and race conditions that apply to the above discussion which I will not elaborate on. They are not hidden from anybody who reads the source code, but they are somewhat technical and difficult (though scarcely impossible) to exploit. Suffice it to say that even under the best of conditions UUCP is not completely secure.

For many sites, security from remote sites is a more important consideration. Fortunately, Taylor UUCP does provide some support in this area.

The greatest security is provided by always dialing out to the other site. This prevents anybody from pretending to be the other site. Of course, only one side of the connection can do this.

If remote dialins must be permitted, then it is best if the dialin line is used only for UUCP. If this is the case, then you should create a call-in password file (see section Configuration File Names) and let `uucico` do its own login prompting. For example, to let remote sites log in on a port named ``entry'` in the port file (see section The Port Configuration File), you might invoke ``uucico -e -p entry'`. This would cause `uucico` to enter an endless loop of login prompts and daemon executions. The advantage of this approach is that even if remote users break into the system by guessing or learning the password, they will only be able to do whatever `uucico` permits them to do. They will not be able to start a shell on your system.

If remote users can dial in and log on to your system, then you have a security hazard more serious than that posed by UUCP. But then, you probably knew that already.

Once your system has connected with the remote UUCP, there is a fair amount of control you can exercise. You can use the `remote-send` and `remote-receive` commands to control the directories the remote UUCP can access. You can use the `request` command to prevent the remote UUCP from making any requests of your system at all; however, if you do this it will not even be able to send you mail or news. If you do permit remote requests, you should be careful to restrict what commands may be executed at the remote system's request. The default is `rmail` and `rnews`, which will suffice for most systems.

If different remote systems call in and they must be granted different privileges (perhaps some systems are within the same organization and some are not) then the `called-login` command should be used for each system to require that they use different login names. Otherwise, it would be simple for a remote system to use the `myname` command and pretend to be a different system. The `sequence` command can be used to detect when one system pretended to be another, but, since the sequence numbers must be reset manually after a failed handshake, this can sometimes be more trouble than it's worth.

Go to the first, previous, next, last section, table of contents.